(function () {
  try {
    return angular.module('bonitasoft.ui.widgets');
  } catch(e) {
    return angular.module('bonitasoft.ui.widgets', []);
  }
})().directive('customDisplayfailedresponse', function() {
    return {
      controllerAs: 'ctrl',
      controller: /**
 * The controller is a JavaScript function that augments the AngularJS scope and exposes functions that can be used in the custom widget template
 * 
 * Custom widget properties defined on the right can be used as variables in a controller with $scope.properties
 * To use AngularJS standard services, you must declare them in the main function arguments.
 * 
 * You can leave the controller empty if you do not need it.
 */
function ($scope) {
    
    this.isError = function () {
        if ($scope.properties.failedResponseValue === undefined)
            return false;
        return $scope.properties.failedResponseValue.hasOwnProperty("message") ;
    };
    
    this.getMessage = function () 
    {
       if ($scope.properties.failedResponseValue === undefined)
            return "";
            
            if($scope.properties.enableDetailedExplanation)
            {
                return extractMessage($scope.properties.failedResponseValue.message);
            }
            else
            {
                if($scope.properties.genericMessage)
                {
                    return $scope.properties.genericMessage;
                }
                else
                {
                    return "Please contact admin.";
                }
            }
       //return $scope.properties.failedResponseValue.message;
    };
    this.getExplanations = function () 
    {
       if ($scope.properties.failedResponseValue === undefined)
            return "";
        return $scope.properties.failedResponseValue.explanations;
    };
    
    var extractMessage = function (exceptionMessage)
    {
        var message = "";
        if (exceptionMessage.indexOf("com.bonitasoft") > -1 || exceptionMessage.indexOf("org.bonitasoft") > -1 )
        {
            if(exceptionMessage.indexOf("with message =") > -1)
            {
                var textPattern = "with message =";
                var pos = exceptionMessage.indexOf(textPattern);
                
                
                message = exceptionMessage.slice(pos + textPattern.length);
                message = extractMessage(message.slice(0, endPos));
                var endPos = message.indexOf("Expression");
                if(endPos > -1)
                {
                    message = message.slice(0, endPos);    
                }
                
            }
            else
            {
                var pos = exceptionMessage.indexOf(":");
                message = exceptionMessage.slice(pos + 1 );    
            }
            
        }
        else
        {
            var endPos = exceptionMessage.indexOf("\r\n");
            message = exceptionMessage.slice(0, endPos);
        }
        
        return message;
    }
},
      template: '<!-- Display the error if it is-->\n \n<span ng-if="environment"><identicon name="{{environment.component.id}}" size="30" background-color="[255,255,255, 0]" foreground-color="[51,51,51]"></identicon> {{environment.component.name}}</span>\n\n<div ng-show="ctrl.isError()">\n    <div class="alert alert-danger">\n        <h3>{{ctrl.getMessage()}}</h3><br>\n        <div ng-repeat="expl in ctrl.getExplanations()">\n            <li><i>{{expl}}</i></li>\n        </div>\n    \n    </div>\n</div>'
    };
  });
